import {Dubbo, TDubboCallResult} from 'dubbo2.js';
import {argumentMap} from 'interpret-util';

export interface IErrorProvider {
  errorTest(): TDubboCallResult<void>;
}

export const ErrorProviderWrapper = {errorTest: argumentMap};

export function ErrorProvider(dubbo: Dubbo): IErrorProvider {
  return dubbo.proxyService<IErrorProvider>({
    dubboInterface: 'com.alibaba.dubbo.demo.ErrorProvider',
    methods: ErrorProviderWrapper,
  });
}
